 ;=======================DTMF Dekodieren und mit Echolink ratschen=================================
;porta, 0 auf MT8870 Pin 11 
;porta, 1 auf MT8870 Pin 12
;porta, 2 auf MT8870 Pin 13 
;porta, 3 auf MT8870 Pin 14 
;porta, 4 auf MT8870 Pin 15 
;portb, 0	empfngt daten seriell von echolink ber Interrupts im PIC gesteuert
;portb, 1	sendet daten seriell an echolink
;portb, 2	schaltet ptt
;portb, 7	zeigt an (ber LED) ob ein dtmf ton empfangen wird

;---------------------------
	list		p=16f627
	__config  		h'3f21'	;oscillator:XT, watchdog timer:off, power-up timer:on, brown out:disabled, MCLRE: enabled,
				;low voltage program:disabled, data EE protect:off, code protect:off
	radix	  	hex

;---------------vom PIC bereitgestellte registerzuordnungen-----------------
pc		equ	0x02
status		equ	0x03	
optionreg		equ	0x81
intcon		equ	0x0b
porta		equ	0x05		;porta definieren
portb		equ	0x06		;portb definieren
trisa		equ	0x85
trisb		equ	0x86
cmcon		equ	0x1f
pie1		equ	0x8c
;-------------------frei definierbare registerzuordnungen
temp		equ	0x20
ccount		equ	0x21
dcount		equ	0x22
dtmf_ton_ist_da	equ	0x23	
rs232in		equ	0x24
byte2send		equ	0x25
byte		equ	0x26
cycl_1		equ	0x27
cycl_2		equ	0x28
status_temp	equ	0x29
w_temp		equ	0x2a


;---------------startadresse des programms--------------------
		org	0x000		;Programmstart
		goto	start
;---------------startadresse der Interruptroutine
		org	0x004
		goto	i_routine

;---------------Tabelle fr dtmf schaltsteuerung (muss am Anfang des Programms stehen, wegen der Adressierung)----------------
test		addwf	pc, 1	;addiere w Register zu programmzhler	wandle nach ascii
		retlw	0x44	; dtmf d		dtmf-code:0000		wird ASCII: "D"
		retlw	0x31	; dtmf 1 		dtmf-code:0001		wird ASCII: "1"
		retlw	0x32	; dtmf 2		dtmf-code:0010		wird ASCII: "2"
		retlw	0x33	; dtmf 3		dtmf-code:0011		wird ASCII: "3"
		retlw	0x34	; dtmf 4		dtmf-code:0100		wird ASCII: "4"
		retlw	0x35	; dtmf 5		dtmf-code:0101		wird ASCII: "5"
		retlw	0x36	; dtmf 6		dtmf-code:0110		wird ASCII: "6"
		retlw	0x37	; dtmf 7		dtmf-code:0111		wird ASCII: "7"
		retlw	0x38	; dtmf 8		dtmf-code:1000		wird ASCII: "8"
		retlw	0x39	; dtmf 9		dtmf-code:1001		wird ASCII: "9"
		retlw	0x30	; dtmf 0		dtmf-code:1010		wird ASCII: "0"
		retlw	0x2a	; dtmf *		dtmf-code:1011		wird ASCII: "*"
		retlw	0x23	; dtmf #		dtmf-code:1100		wird ASCII: "#"
		retlw	0x41	; dtmf a		dtmf-code:1101		wird ASCII: "A"
		retlw	0x42	; dtmf b		dtmf-code:1110		wird ASCII: "B"
		retlw	0x43	; dtmf c		dtmf-code:1111		wird ASCII: "C"

;---------------start hauptprogramm-------------
start		movlw	b'00000000'		;verbiete interrupts
		movwf	intcon
		bsf	status, 5
		clrf	pie1		;verbiete alle interrupts die wir nicht brauchen
		bcf	status, 5
		clrf	portb		;portb auf 0000 0000 setzen
		clrf	porta		;selbiges fr porta
		movlw	0x07		;Komparator Modul an porta ausschalten und
		movwf	cmcon		;porta als digitale ein/ausgnge definieren
		bsf	status, 5
		movlw 	0x01		;w Register mit binr 0000 0001 laden
		movwf	trisb		;0000 0001 in trisb laden,portb alle outputs bis auf portb, 0:input
		movlw	0xff
		movwf	trisa		;porta alle inputs
		bcf	status, 5
		clrf	dtmf_ton_ist_da	;byte in dem steht ob ein dtmf ton empfangen wurde
		bsf	status, 5
		bsf	optionreg, 6		;interrupt bei steigender flanke an portb, 0
		bcf	status, 5
		movlw	b'10010000'		;erlaube nur externen interrupt an portb, 0   
		movwf	intcon
;------------------------schauen ob ein dtmf ton empfangen wird----------------------------------
strob		btfss  	porta, 4     		;bit 4 in porta testen auf 1, dtmf signal liegt an
		goto	strob		;wenn porta bit 4 = 1 (kein signal)springe nach strobe, bei 0,nchste zeile
		call	pause		;puschen, falls der strobe pin vom 8870 "flattert"
		btfss	porta, 4		;bit 4 in porta testen auf 1
		goto	strob		;wenn porta bit 4 = 0 springe nach strobe,bei 1 nchste zeile

;-------------------dtmf ton wird empfangen------------
		bsf	portb, 7		;dtmf ton liegt an
		movf	porta, 0		;Daten von porta ins w Register kopieren (dtmf ton dkodierung vom mt8870 
		andlw	b'00001111'		;setzt bit 4 in w Register auf 0 (brauch ma nicht, ist nur das strobe vom 8870; andere unverndert 
		call	test		;Aufruf Tabelle test (Wandlung des gehrten dtmf tons in den entsprechenden ASCII Code)
		movwf	byte2send		;Speichern des entsprechenden ASCII Codes in "byte2send"
		bsf	dtmf_ton_ist_da, 0	;und merken, dass ein dtmf ton empfangen wurde 
		btfsc	porta, 4		;Warte bis der dtmf ton wieder aufhrt
		goto	$-1		;ist noch da
		bcf	portb, 7		;dtmf ton hat aufgehrt
		call	pause		;dtmf ton hat aufgehrt, kurzes ruhepuschen
		goto	strob		;und warten auf die nchste eingabe eines dtmf tons		



;====================HIER STEHT DIE INTERRUPTROUTINE============

;**********************************************************
;empfangen eines Byte nach 'byte', 'rs232in' und w 

i_routine		movwf	w_temp		;retten des w-registers in w_temp
		swapf	status, 0
		movwf	status_temp	;retten des status registers in status_temp	

ser_RX		clrf	byte		;empfangregister fr daten von echolink
		movlw	0x08
		movwf	cycl_1		;8 mal schleife, da 8 bit empfangne werden	
		call	Pause		; Zeitverzgerung 1/2 Bit
		btfss	portb, 0		;liegt wirklich startbit an
		goto	nachhause		;war ein irrtum in die interruptroutine zu springen, haben wir wohl mist auf der Leitung gehrt
		;startbit war gltig
RX_2		call	Warte		; Zeitverzgerung 1 Bit
		btfsc	portb, 0		;bit abtasten
		goto	clearport0		 
		goto	setport0
clearport0		bcf	status, 0		;empfangenes bit invertieren high -> 0
		goto	$+2
setport0		bsf	status, 0		;empfangenes bit invertierem low  -> 1
					;
		rrf	byte, 1		;
		decfsz	cycl_1, 1	;
		goto	RX_2		; 8 mal
		
		call	Warte		;Zeitverzoegerung 1 bit
		;stoppbit testen  		
		btfsc	portb, 0		;liegt ein Stop-Bit an
		goto	nachhause		;nein, kein stop bit, dann haben wir wohl die ganze zeit nur mist auf der leitung gehrt
		;stop bit war ok
		movf	byte, 0		;empfangene daten in register rs232in umkopieren
		movwf	rs232in
		
		;jetzt steht das kommando das echolink gesendet hat im register "rs232in"
		;jetzt schau ma was zu tun ist
		movlw	'T'		;hat echolink ein "T" gesendet?
		subwf	rs232in, 0		
		btfss	status, 2		
		goto	$+2		;es war kein "T"	
		goto	transmit		;es war ein "T"
		
		movlw	'R'		;dann wars vielleicht ein "R"
		subwf	rs232in, 0		
		btfss	status,2
		goto	$+2		;es war kein "R" 
		goto	receive		;es war ein "R"
		
		;es war weder ein R noch ein T, dann kanns nur noch ein C gewesen sein
		movlw	'C'
		subwf	rs232in, 0
		btfss	status, 2
		goto	nachhause		; es war kein T, R oder C, dann haben wir uns verhrt, also zurck ins hauptprogramm
		goto	dtmf		;es war ein C


;==================Echolink will, dass wir auf Sendung gehen		
transmit		movlw	'K'		;wir besttigen den Empfang des Zeichens an echolink	
		call	send_RS		
		bsf	portb, 2		;und schalten auf sendung, ptt ein
		goto	nachhause		;und zurck ins hauptprogramm

;=================Echolink will, dass wir auf Empfang gehen		
receive		movlw	'K'		;wir besttigen den Empfang des Zeichens an Echolink
		call	send_RS
		bcf	portb, 2		;und schalten ptt wieder aus
		goto	nachhause		;und zurck ins hauptprogramm
		
;=================Echolink will wissen ob wir einen dtmf ton gehrt haben
dtmf		btfss	dtmf_ton_ist_da, 0	;wurde vor der interrupttoutine ein gltiger dtmf ton erkannt
		goto	kein_dtmf_ton	;nein, es wurde kein dtmf ton gehrt	
		goto	dtmf_ton		;ja, dtmf ton wurde detektiert
		
kein_dtmf_ton	movlw	' '		;wir melden: kein dtmf ton gehrt
		call	send_RS	
		goto	nachhause		;und zurck ins hauptprogramm


dtmf_ton		bcf	dtmf_ton_ist_da, 0	;rcksetzen des erkennungsbites fr dtmf tne				
		movf	byte2send, 0	;wir senden den erkannten dtmf ton
		call	send_RS
		movlw	' '		;wir melden: ein dtmf ton gehrt (ber ASCII "Space")
		call	send_RS	
		goto	nachhause		;und zurck ins hauptprogramm
		;ende der Interruptroutine
nachhause		swapf	status_temp, 0	;zurckschreiben des originalen status
		movwf	status		;registers
		swapf	w_temp, 1		;und des originalen 
		swapf	w_temp, 0		;w-registers
			
		bcf	intcon, 1		;ab jetzt sind wieder interrupts erlaubt
		
		retfie			;zurck ins Hauptprogramm

;**********************************************************
;ein bit zeitverzoegerung
; dieses timing mu genau stimmen (5%)
;
; empfang           3,579545 MHz  
; 2400 Bps =          d'61'
;
Warte		movlw	d'61'		; 9600 Bps / 4 MHz empfangen
		movwf	cycl_2 
Warte1				; 6 Zyklen-Schleife
		nop
		nop
		nop
		decfsz	cycl_2, 1	
		goto	Warte1
		return

;**********************************************************
;1/2 bit zeitverzoegerung
; dieses Timing ist nicht ganz so kritisch (25%)
;
;                		3.579545 MHz
; 2400 Bps =	d'60'
;
Pause		movlw	d'60'		 
		movwf	temp
Pause2				; 3 Zyklen Schleife
		decfsz	temp, 1	
		goto	Pause2
		return

;**********************************************************


;====================HIER ENDET DIE INTERRUPTROUTINE===============


;---------------subroutinen-----------------

;=========SENDEN EINES BYTES AN ECHOLINK

send_RS				; Ausgabe eines Bytes seriell	
	movwf	byte		; Datenbyte in  in w
	movlw	0x08		; es werden 8 Bit gesendet
	movwf 	cycl_1
	bsf	portb, 1		;sende Startbit
	call	Warte_s		
	
Send_1	btfsc	byte, 0		;schau, ob zu sendendes bit high oder low ist
	goto	clearport		;bit ist high
	goto	setport		;bit ist low
clearport	bcf	portb, 1		;sende bit: bit muss invertiert werden
	call	Warte_s
	goto	weiter_senden
setport	bsf	portb, 1		;sende bit: bit muss invertiert werden
	call	Warte_s		; 1 Bit lang warten
	goto	weiter_senden
weiter_senden	rrf	byte, 1	;und nchstes bit holen
	decfsz	cycl_1, 1
	goto	Send_1
	bcf	portb, 1		;Stoppbit senden
	call	Warte_s	
	call	Warte_s		;zur sicherheit ein bischen lnger warten
	return			;und zurck

;**********************************************************
;ein Bit Zeitverzoegerung mit einer Warteschleife
; Timing mu genau stimmen (5%)
;
; senden           	3.579545 MHZ	 
; 2400 Bps =          	d'61d'

Warte_s	movlw	d'61'		 
	movwf	cycl_2
Warte10				; 6 Zyklen Schleife
	nop
	nop
	nop
	decfsz	cycl_2, 1	
	goto	Warte10
	return
;=========ENDE SENDEN EINES BYTES AN ECHOLINK

;------------------------Pause mit ca. 5 mS Dauer
pause		movlw	d'38'	;pause mit ca. 5ms dauer
		movwf	ccount	;berechnung: Wert(ccount) * Wert(dcount) * 3 * (4/sysclk(KHz)) = pausendauer in mS 
load1		movlw	d'39'	
		movwf	dcount
dec1		decfsz	dcount, 1
		goto	dec1
		decfsz	ccount, 1
		goto	load1
		return			
	
	
		end
